syntax = {'formats': {'builtin': '%(syntax_builtin)s',
                      'comment': '%(syntax_comment)s',
                      'hexnumber': '%(syntax_number)s',
                      'keyword': '%(syntax_keyword)s',
                      'number': '%(syntax_number)s',
                      'decorator': '%(syntax_decorator)s',
                      'string': '%(syntax_string)s',
                      'obsolete': '%(syntax_obsolete)s'},
          'partitions': [('comment', '#', '\n'),
                         ('string', "[buBU]?[rR]?'''", "'''", True),
                         ('string', "[buBU]?[rR]?'", "'"),
                         ('string', '[buBU]?[rR]?"""', '"""', True),
                         ('string', '[buBU]?[rR]?"', '"')],
          'scanner': {None: [('hexnumber', '(0x)([0-9a-fA-F])+?'),
                             ('number', r'[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?[jJ]?'),
                             ('obsolete', r'\s*\bprint\b(?!\s*\()'),
                             ('keyword',
                              ['and',
                               'as',
                               'assert',
                               'break',
                               'class',
                               'continue',
                               'def',
                               'del',
                               'elif',
                               'else',
                               'except',
                               'exec',
                               'finally',
                               'for',
                               'from',
                               'global',
                               'if',
                               'import',
                               'in',
                               'is',
                               'lambda',
                               'not',
                               'or',
                               'pass',
                               #'print',
                               'raise',
                               'return',
                               'try',
                               'while',
                               'with',
                               'yield'],
                              '(^|[\x08\\W])',
                              '[\x08\\W]'),
                             ('builtin',
                              ['ArithmeticError',
                               'AssertionError',
                               'AttributeError',
                               'BaseException',
                               'BufferError',
                               'BytesWarning',
                               'DeprecationWarning',
                               'EOFError',
                               'Ellipsis',
                               'EnvironmentError',
                               'Exception',
                               'False',
                               'FloatingPointError',
                               'FutureWarning',
                               'GeneratorExit',
                               'IOError',
                               'ImportError',
                               'ImportWarning',
                               'IndentationError',
                               'IndexError',
                               'KeyError',
                               'KeyboardInterrupt',
                               'LookupError',
                               'MemoryError',
                               'NameError',
                               'None',
                               'NotImplemented',
                               'NotImplementedError',
                               'OSError',
                               'OverflowError',
                               'PendingDeprecationWarning',
                               'ReferenceError',
                               'RuntimeError',
                               'RuntimeWarning',
                               'StandardError',
                               'StopIteration',
                               'SyntaxError',
                               'SyntaxWarning',
                               'SystemError',
                               'SystemExit',
                               'TabError',
                               'True',
                               'TypeError',
                               'UnboundLocalError',
                               'UnicodeDecodeError',
                               'UnicodeEncodeError',
                               'UnicodeError',
                               'UnicodeTranslateError',
                               'UnicodeWarning',
                               'UserWarning',
                               'ValueError',
                               'Warning',
                               'ZeroDivisionError',
                               '__import__',
                               'abs',
                               'all',
                               'any',
                               'apply',
                               'basestring',
                               'bin',
                               'bool',
                               'buffer',
                               'bytearray',
                               'bytes',
                               'callable',
                               'chr',
                               'classmethod',
                               'cmp',
                               'coerce',
                               'compile',
                               'complex',
                               'copyright',
                               'credits',
                               'delattr',
                               'dict',
                               'dir',
                               'divmod',
                               'enumerate',
                               'eval',
                               'execfile',
                               'exit',
                               'file',
                               'filter',
                               'float',
                               'format',
                               'frozenset',
                               'getattr',
                               'globals',
                               'hasattr',
                               'hash',
                               'help',
                               'hex',
                               'id',
                               'input',
                               'int',
                               'intern',
                               'isinstance',
                               'issubclass',
                               'iter',
                               'len',
                               'license',
                               'list',
                               'locals',
                               'long',
                               'map',
                               'max',
                               'memoryview',
                               'min',
                               'next',
                               'object',
                               'oct',
                               'open',
                               'ord',
                               'pow',
                               'print',
                               'property',
                               'quit',
                               'range',
                               'raw_input',
                               'reduce',
                               'reload',
                               'repr',
                               'reversed',
                               'round',
                               'self',
                               'set',
                               'setattr',
                               'slice',
                               'sorted',
                               'staticmethod',
                               'str',
                               'sum',
                               'super',
                               'tuple',
                               'type',
                               'unichr',
                               'unicode',
                               'vars',
                               'xrange',
                               'zip'],
                              '(^|[^\\.\\w])',
                              '[\x08\\W]'),
                             ('decorator', '^\s*@[A-Za-z_][A-Za-z_0-9]*'),
                             ('ident', '[A-Za-z_][A-Za-z_0-9]*')]}}
